## tdesktop-6.2.3-full.tar.gz

=== cmake/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_subdirectory(external)
if (DESKTOP_APP_USE_ALLOCATION_TRACER)
    add_subdirectory(linux_allocation_tracer)
endif()
if (WIN32 AND QT_VERSION LESS 6)
    add_subdirectory(win_directx_helper)
endif()

=== Telegram/lib_ui/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(lib_ui STATIC)
add_library(desktop-app::lib_ui ALIAS lib_ui)
init_target(lib_ui)

include(cmake/generate_palette.cmake)
include(cmake/generate_styles.cmake)
include(cmake/generate_emoji.cmake)

get_filename_component(src_loc . REALPATH)

set(style_files
    ui/basic.style
    ui/layers/layers.style
    ui/widgets/widgets.style
)

generate_palette(lib_ui ui/colors.palette)
generate_styles(lib_ui ${src_loc} "${style_files}" ui/colors.palette)
generate_emoji(lib_ui emoji.txt emoji_suggestions/emoji_autocomplete.json)

set_target_properties(lib_ui PROPERTIES AUTOMOC ON)

target_precompile_headers(lib_ui PRIVATE $<$<COMPILE_LANGUAGE:CXX,OBJCXX>:${src_loc}/ui/ui_pch.h>)
nice_target_sources(lib_ui ${src_loc}
PRIVATE
    ${style_files}
    ui/colors.palette
    emoji_suggestions/emoji_autocomplete.json

    fonts/fonts.qrc
    qt_conf/win.qrc

    ui/dpr/dpr_icon.cpp
    ui/dpr/dpr_icon.h
    ui/dpr/dpr_image.h
    ui/effects/animation_value.cpp
    ui/effects/animation_value.h
    ui/effects/animation_value_f.h
    ui/effects/animations.cpp
    ui/effects/animations.h
    ui/effects/cross_animation.cpp
    ui/effects/cross_animation.h
    ui/effects/cross_line.cpp
    ui/effects/cross_line.h
    ui/effects/fade_animation.cpp
    ui/effects/fade_animation.h
    ui/effects/frame_generator.cpp
    ui/effects/frame_generator.h
    ui/effects/gradient.cpp
    ui/effects/gradient.h
    ui/effects/numbers_animation.cpp
    ui/effects/numbers_animation.h
    ui/effects/panel_animation.cpp
    ui/effects/panel_animation.h
    ui/effects/path_shift_gradient.cpp
    ui/effects/path_shift_gradient.h
    ui/effects/radial_animation.cpp
    ui/effects/radial_animation.h
    ui/effects/ripple_animation.cpp
    ui/effects/ripple_animation.h
    ui/effects/round_area_with_shadow.cpp
    ui/effects/round_area_with_shadow.h
    ui/effects/show_animation.cpp
    ui/effects/show_animation.h
    ui/effects/slide_animation.cpp
    ui/effects/slide_animation.h
    ui/effects/spoiler_mess.cpp
    ui/effects/spoiler_mess.h
    ui/gl/gl_detection.cpp
    ui/gl/gl_detection.h
    ui/gl/gl_image.cpp
    ui/gl/gl_image.h
    ui/gl/gl_math.cpp
    ui/gl/gl_math.h
    ui/gl/gl_primitives.cpp
    ui/gl/gl_primitives.h
    ui/gl/gl_shader.cpp
    ui/gl/gl_shader.h
    ui/gl/gl_surface.cpp
    ui/gl/gl_surface.h
    ui/gl/gl_window.cpp
    ui/gl/gl_window.h
    ui/image/image_prepare.cpp
    ui/image/image_prepare.h
    ui/layers/box_content.cpp
    ui/layers/box_content.h
    ui/layers/box_layer_widget.cpp
    ui/layers/box_layer_widget.h
    ui/layers/generic_box.cpp
    ui/layers/generic_box.h
    ui/layers/layer_manager.cpp
    ui/layers/layer_manager.h
    ui/layers/layer_widget.cpp
    ui/layers/layer_widget.h
    ui/layers/show.cpp
    ui/layers/show.h
    ui/paint/arcs.cpp
    ui/paint/arcs.h
    ui/paint/blob.cpp
    ui/paint/blob.h
    ui/paint/blobs.cpp
    ui/paint/blobs.h
    ui/paint/blobs_linear.cpp
    ui/paint/blobs_linear.h
    ui/platform/linux/ui_window_linux.cpp
    ui/platform/linux/ui_window_linux.h
    ui/platform/linux/ui_window_title_linux.cpp
    ui/platform/linux/ui_window_title_linux.h
    ui/platform/linux/ui_utility_linux.cpp
    ui/platform/linux/ui_utility_linux.h
    ui/platform/mac/ui_window_mac.h
    ui/platform/mac/ui_window_mac.mm
    ui/platform/mac/ui_window_title_mac.h
    ui/platform/mac/ui_window_title_mac.mm
    ui/platform/mac/ui_utility_mac.h
    ui/platform/mac/ui_utility_mac.mm
    ui/platform/win/ui_window_shadow_win.cpp
    ui/platform/win/ui_window_shadow_win.h
    ui/platform/win/ui_window_title_win.cpp
    ui/platform/win/ui_window_title_win.h
    ui/platform/win/ui_window_win.cpp
    ui/platform/win/ui_window_win.h
    ui/platform/win/ui_windows_direct_manipulation.cpp
    ui/platform/win/ui_windows_direct_manipulation.h
    ui/platform/win/ui_windows_native_event_filter.cpp
    ui/platform/win/ui_windows_native_event_filter.h
    ui/platform/win/ui_utility_win.cpp
    ui/platform/win/ui_utility_win.h
    ui/platform/ui_platform_window_title.cpp
    ui/platform/ui_platform_window_title.h
    ui/platform/ui_platform_window.cpp
    ui/platform/ui_platform_window.h
    ui/platform/ui_platform_utility.h
    ui/style/style_core.cpp
    ui/style/style_core.h
    ui/style/style_core_color.cpp
    ui/style/style_core_color.h
    ui/style/style_core_direction.cpp
    ui/style/style_core_direction.h
    ui/style/style_core_font.cpp
    ui/style/style_core_font.h
    ui/style/style_core_icon.cpp
    ui/style/style_core_icon.h
    ui/style/style_core_palette.cpp
    ui/style/style_core_palette.h
    ui/style/style_core_scale.cpp
    ui/style/style_core_scale.h
    ui/style/style_core_types.cpp
    ui/style/style_core_types.h
    ui/style/style_palette_colorizer.cpp
    ui/style/style_palette_colorizer.h
    ui/text/custom_emoji_helper.cpp
    ui/text/custom_emoji_helper.h
    ui/text/custom_emoji_instance.cpp
    ui/text/custom_emoji_instance.h
    ui/text/custom_emoji_text_badge.cpp
    ui/text/custom_emoji_text_badge.h
    ui/text/text.cpp
    ui/text/text.h
    ui/text/text_bidi_algorithm.h
    ui/text/text_block.cpp
    ui/text/text_block.h
    ui/text/text_block_parser.cpp
    ui/text/text_block_parser.h
    ui/text/text_custom_emoji.cpp
    ui/text/text_custom_emoji.h
    ui/text/text_entity.cpp
    ui/text/text_entity.h
    ui/text/text_extended_data.cpp
    ui/text/text_extended_data.h
    ui/text/text_isolated_emoji.h
    ui/text/text_renderer.cpp
    ui/text/text_renderer.h
    ui/text/text_stack_engine.cpp
    ui/text/text_stack_engine.h
    ui/text/text_utilities.cpp
    ui/text/text_utilities.h
    ui/text/text_variant.cpp
    ui/text/text_variant.h
    ui/text/text_word.h
    ui/text/text_word_parser.cpp
    ui/text/text_word_parser.h
    ui/toast/toast.cpp
    ui/toast/toast.h
    ui/toast/toast_manager.cpp
    ui/toast/toast_manager.h
    ui/toast/toast_widget.cpp
    ui/toast/toast_widget.h
    ui/widgets/box_content_divider.cpp
    ui/widgets/box_content_divider.h
    ui/widgets/buttons.cpp
    ui/widgets/buttons.h
    ui/widgets/call_button.cpp
    ui/widgets/call_button.h
    ui/widgets/checkbox.cpp
    ui/widgets/checkbox.h
    ui/widgets/dropdown_menu.cpp
    ui/widgets/dropdown_menu.h
    ui/widgets/icon_button_with_text.cpp
    ui/widgets/icon_button_with_text.h
    ui/widgets/inner_dropdown.cpp
    ui/widgets/inner_dropdown.h
    ui/widgets/fields/custom_field_object.cpp
    ui/widgets/fields/custom_field_object.h
    ui/widgets/fields/input_field.cpp
    ui/widgets/fields/input_field.h
    ui/widgets/fields/masked_input_field.cpp
    ui/widgets/fields/masked_input_field.h
    ui/widgets/fields/number_input.cpp
    ui/widgets/fields/number_input.h
    ui/widgets/fields/password_input.cpp
    ui/widgets/fields/password_input.h
    ui/widgets/fields/time_part_input.cpp
    ui/widgets/fields/time_part_input.h
    ui/widgets/labels.cpp
    ui/widgets/labels.h
    ui/widgets/menu/menu.cpp
    ui/widgets/menu/menu.h
    ui/widgets/menu/menu_action.cpp
    ui/widgets/menu/menu_action.h
    ui/widgets/menu/menu_add_action_callback.cpp
    ui/widgets/menu/menu_add_action_callback.h
    ui/widgets/menu/menu_add_action_callback_factory.cpp
    ui/widgets/menu/menu_add_action_callback_factory.h
    ui/widgets/menu/menu_common.cpp
    ui/widgets/menu/menu_common.h
    ui/widgets/menu/menu_item_base.cpp
    ui/widgets/menu/menu_item_base.h
    ui/widgets/menu/menu_multiline_action.cpp
    ui/widgets/menu/menu_multiline_action.h
    ui/widgets/menu/menu_separator.cpp
    ui/widgets/menu/menu_separator.h
    ui/widgets/menu/menu_toggle.cpp
    ui/widgets/menu/menu_toggle.h
    ui/widgets/elastic_scroll.cpp
    ui/widgets/elastic_scroll.h
    ui/widgets/popup_menu.cpp
    ui/widgets/popup_menu.h
    ui/widgets/rp_window.cpp
    ui/widgets/rp_window.h
    ui/widgets/separate_panel.cpp
    ui/widgets/separate_panel.h
    ui/widgets/scroll_area.cpp
    ui/widgets/scroll_area.h
    ui/widgets/side_bar_button.cpp
    ui/widgets/side_bar_button.h
    ui/widgets/shadow.cpp
    ui/widgets/shadow.h
    ui/widgets/time_input.cpp
    ui/widgets/time_input.h
    ui/widgets/tooltip.cpp
    ui/widgets/tooltip.h
    ui/wrap/fade_wrap.cpp
    ui/wrap/fade_wrap.h
    ui/wrap/follow_slide_wrap.cpp
    ui/wrap/follow_slide_wrap.h
    ui/wrap/padding_wrap.cpp
    ui/wrap/padding_wrap.h
    ui/wrap/slide_wrap.cpp
    ui/wrap/slide_wrap.h
    ui/wrap/table_layout.cpp
    ui/wrap/table_layout.h
    ui/wrap/vertical_layout.cpp
    ui/wrap/vertical_layout.h
    ui/wrap/vertical_layout_reorder.cpp
    ui/wrap/vertical_layout_reorder.h
    ui/wrap/wrap.h
    ui/abstract_button.cpp
    ui/abstract_button.h
    ui/animated_icon.cpp
    ui/animated_icon.h
    ui/arc_angles.h
    ui/basic_click_handlers.cpp
    ui/basic_click_handlers.h
    ui/cached_special_layer_shadow_corners.cpp
    ui/cached_special_layer_shadow_corners.h
    ui/click_handler.cpp
    ui/click_handler.h
    ui/delayed_activation.cpp
    ui/delayed_activation.h
    ui/dragging_scroll_manager.cpp
    ui/dragging_scroll_manager.h
    ui/dynamic_image.h
    ui/emoji_config.cpp
    ui/emoji_config.h
    ui/focus_persister.h
    ui/inactive_press.cpp
    ui/inactive_press.h
    ui/integration.cpp
    ui/integration.h
    ui/main_queue_processor.cpp
    ui/main_queue_processor.h
    ui/painter.h
    ui/ph.cpp
    ui/ph.h
    ui/qt_object_factory.h
    ui/rect.h
    ui/rect_part.h
    ui/round_rect.cpp
    ui/round_rect.h
    ui/rp_widget.cpp
    ui/rp_widget.h
    ui/ui_rpl_filter.h
    ui/ui_utility.cpp
    ui/ui_utility.h

    ui/ui_pch.h

    emoji_suggestions/emoji_suggestions.cpp
    emoji_suggestions/emoji_suggestions.h
    emoji_suggestions/emoji_suggestions_helper.h
)

if (DESKTOP_APP_USE_PACKAGED_FONTS)
    target_compile_definitions(lib_ui PRIVATE LIB_UI_USE_PACKAGED_FONTS)
    remove_target_sources(lib_ui ${src_loc} fonts/fonts.qrc)
endif()

target_include_directories(lib_ui
PUBLIC
    ${src_loc}
    ${src_loc}/emoji_suggestions
)

target_link_libraries(lib_ui
PUBLIC
    desktop-app::lib_base
PRIVATE
    desktop-app::external_zlib
    desktop-app::external_jpeg
    desktop-app::external_lz4
    desktop-app::external_xxhash
)

if (WIN32 AND QT_VERSION LESS 6)
    target_link_libraries(lib_ui PRIVATE desktop-app::external_angle)
endif()

target_prepare_qrc(lib_ui)

=== Telegram/lib_webrtc/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(lib_webrtc OBJECT)
add_library(desktop-app::lib_webrtc ALIAS lib_webrtc)
init_target(lib_webrtc)

get_filename_component(src_loc . REALPATH)

target_precompile_headers(lib_webrtc PRIVATE ${src_loc}/webrtc/webrtc_pch.h)
nice_target_sources(lib_webrtc ${src_loc}
PRIVATE
    webrtc/webrtc_audio_input_tester.cpp
    webrtc/webrtc_audio_input_tester.h
    webrtc/webrtc_create_adm.cpp
    webrtc/webrtc_create_adm.h
    webrtc/webrtc_device_common.h
    webrtc/webrtc_device_resolver.cpp
    webrtc/webrtc_device_resolver.h
    webrtc/webrtc_environment.cpp
    webrtc/webrtc_environment.h
    webrtc/webrtc_video_track.cpp
    webrtc/webrtc_video_track.h

    webrtc/details/webrtc_environment_openal.cpp
    webrtc/details/webrtc_environment_openal.h
    webrtc/details/webrtc_environment_video_capture.cpp
    webrtc/details/webrtc_environment_video_capture.h
    webrtc/details/webrtc_openal_adm.cpp
    webrtc/details/webrtc_openal_adm.h

    webrtc/platform/linux/webrtc_environment_linux.cpp
    webrtc/platform/linux/webrtc_environment_linux.h
    webrtc/platform/mac/webrtc_environment_mac.h
    webrtc/platform/mac/webrtc_environment_mac.mm
    webrtc/platform/win/webrtc_environment_win.cpp
    webrtc/platform/win/webrtc_environment_win.h
    webrtc/platform/win/webrtc_loopback_adm_win.cpp
    webrtc/platform/win/webrtc_loopback_adm_win.h
    webrtc/platform/webrtc_platform_environment.h

    webrtc/webrtc_pch.h
)

if (WIN32)
    target_compile_definitions(lib_webrtc
    PRIVATE
        WEBRTC_WIN
    )
elseif (APPLE)
    target_compile_definitions(lib_webrtc
    PRIVATE
        WEBRTC_MAC
    )
endif()

target_include_directories(lib_webrtc
PUBLIC
    ${src_loc}
)

target_link_libraries(lib_webrtc
PUBLIC
    desktop-app::lib_base
    desktop-app::lib_ffmpeg
    desktop-app::external_qt
    desktop-app::external_openal
PRIVATE
    desktop-app::external_webrtc
)

=== Telegram/ThirdParty/GSL/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14...3.16)

project(GSL VERSION 4.1.0 LANGUAGES CXX)

add_library(GSL INTERFACE)
add_library(Microsoft.GSL::GSL ALIAS GSL)

# https://cmake.org/cmake/help/latest/variable/PROJECT_IS_TOP_LEVEL.html
string(COMPARE EQUAL ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_SOURCE_DIR} PROJECT_IS_TOP_LEVEL)

option(GSL_INSTALL "Generate and install GSL target" ${PROJECT_IS_TOP_LEVEL})
option(GSL_TEST "Build and perform GSL tests" ${PROJECT_IS_TOP_LEVEL})

# The implementation generally assumes a platform that implements C++14 support
target_compile_features(GSL INTERFACE "cxx_std_14")

# Setup include directory
add_subdirectory(include)

target_sources(GSL INTERFACE $<BUILD_INTERFACE:${GSL_SOURCE_DIR}/GSL.natvis>)

if (GSL_TEST)
    enable_testing()
    add_subdirectory(tests)
endif()

if (GSL_INSTALL)
    include(GNUInstallDirs)
    include(CMakePackageConfigHelpers)

    install(DIRECTORY "${PROJECT_SOURCE_DIR}/include/gsl" DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

    set(export_name "Microsoft.GSLConfig")
    set(namespace "Microsoft.GSL::")
    set(cmake_files_install_dir ${CMAKE_INSTALL_DATADIR}/cmake/Microsoft.GSL)

    install(TARGETS GSL EXPORT ${export_name} INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
    install(EXPORT ${export_name} NAMESPACE ${namespace} DESTINATION ${cmake_files_install_dir})
    export(TARGETS GSL NAMESPACE ${namespace} FILE ${export_name}.cmake)

    set(gls_config_version "${CMAKE_CURRENT_BINARY_DIR}/Microsoft.GSLConfigVersion.cmake")

    write_basic_package_version_file(${gls_config_version} COMPATIBILITY SameMajorVersion ARCH_INDEPENDENT)

    install(FILES ${gls_config_version} DESTINATION ${cmake_files_install_dir})

    install(FILES GSL.natvis DESTINATION ${cmake_files_install_dir})
endif()

=== Telegram/ThirdParty/expected/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)
project(tl-expected
  HOMEPAGE_URL https://tl.tartanllama.xyz
  DESCRIPTION "C++11/14/17 std::expected with functional-style extensions"
  VERSION 1.0.0
  LANGUAGES CXX)

include(CMakePackageConfigHelpers)
include(CMakeDependentOption)
include(GNUInstallDirs)
include(FetchContent)
include(CTest)

if (NOT DEFINED CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

option(EXPECTED_BUILD_PACKAGE "Build package files as well" ON)

cmake_dependent_option(EXPECTED_BUILD_TESTS
  "Enable tl::expected tests" ON
  "BUILD_TESTING" OFF)

cmake_dependent_option(EXPECTED_BUILD_PACKAGE_DEB
  "Create a DEB" ON
  "EXPECTED_BUILD_PACKAGE" OFF)

add_library(expected INTERFACE)
target_include_directories(expected
  INTERFACE
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

if (NOT CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
  add_library(tl::expected ALIAS expected)
endif()

# Installation help
configure_package_config_file(
  "${PROJECT_SOURCE_DIR}/cmake/${PROJECT_NAME}-config.cmake.in"
  "${PROJECT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
  INSTALL_DESTINATION "share/cmake/${PROJECT_NAME}")

write_basic_package_version_file(
  "${PROJECT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  COMPATIBILITY SameMajorVersion
  ARCH_INDEPENDENT)

install(TARGETS expected
  EXPORT ${PROJECT_NAME}-targets
  INCLUDES DESTINATION "${CMAKE_INSTALL_DATADIR}")

install(EXPORT ${PROJECT_NAME}-targets
  DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${PROJECT_NAME}"
  NAMESPACE tl::
  FILE "${PROJECT_NAME}-targets.cmake")

install(FILES
  "${PROJECT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  "${PROJECT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
  DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${PROJECT_NAME}")

install(DIRECTORY "include/" TYPE INCLUDE)

if(EXPECTED_BUILD_TESTS)
  set(CMAKE_POLICY_DEFAULT_CMP0077 NEW)
  set(CATCH_INSTALL_HELPERS OFF)
  set(CATCH_BUILD_TESTING OFF)
  set(CATCH_INSTALL_DOCS OFF)
  FetchContent_Declare(Catch2 URL
    https://github.com/catchorg/Catch2/archive/v2.13.10.zip) 
  FetchContent_MakeAvailable(Catch2)

  file(GLOB test-sources CONFIGURE_DEPENDS tests/*.cpp)
  list(FILTER test-sources EXCLUDE REGEX "tests/test.cpp")
  add_executable(${PROJECT_NAME}-tests "${test-sources}")
  target_compile_options(${PROJECT_NAME}-tests PRIVATE
    $<$<NOT:$<CXX_COMPILER_ID:MSVC>>:-Wall -Wextra>)

  target_link_libraries(${PROJECT_NAME}-tests
    PRIVATE
      Catch2::Catch2
      expected)
  add_test(NAME tl::expected::tests COMMAND ${PROJECT_NAME}-tests)
endif()

if (NOT EXPECTED_BUILD_PACKAGE)
  return()
endif()

list(APPEND source-generators TBZ2 TGZ TXZ ZIP)

if (CMAKE_HOST_WIN32)
  list(APPEND binary-generators "WIX")
endif()

if (EXPECTED_BUILD_PACKAGE_DEB)
  list(APPEND binary-generators "DEB")
endif()

if (EXPECTED_BUILD_RPM)
  list(APPEND binary-generators "RPM")
endif()


set(CPACK_SOURCE_GENERATOR ${source-generators})
set(CPACK_GENERATOR ${binary-generators})

set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_FILE_NAME}")

set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Sy Brand")

list(APPEND CPACK_SOURCE_IGNORE_FILES /.git/ /build/ .gitignore .DS_Store)

include(CPack)

=== Telegram/ThirdParty/hime/Makefile ===
include config.mak

VERSION_FILE = ChangeLog

DIRS    = src data filter icons man menu scripts

ifeq ($(ECHO),)
ECHO  := $(shell whereis -b echo | awk '{print $$2}')
ifeq ($(ECHO),)
ECHO   = echo
endif
endif

ifeq ($(USE_I18N),Y)
DIRS   += po
endif

.PHONY: all
all:
	@for d in $(DIRS); do $(ECHO) -e "\x1b[1;33m** processing $$d\x1b[0m"; \
	   $(MAKE) -C $$d || exit 1; \
	done

.PHONY: install
install:
	@for d in $(DIRS); do $(ECHO) -e "\x1b[1;32m** installing $$d\x1b[0m"; \
	   $(MAKE) -C $$d install || exit 1; \
	done
	install -d "$(DOC_DIR)"; \
	install -m 644 $(VERSION_FILE) "$(DOC_DIR)"

.PHONY: uninstall
uninstall:
	@for d in $(DIRS); do $(ECHO) -e "\x1b[1;32m** uninstalling $$d\x1b[0m"; \
	   $(MAKE) -C $$d uninstall || exit 1; \
	done

.PHONY: clean
clean:
	@touch src/.depend
	@for d in $(DIRS); do $(ECHO) -e "\x1b[1;31m** cleanup $$d\x1b[0m"; \
	   $(MAKE) -C $$d clean; \
	done

.PHONY: distclean
distclean:
	@$(MAKE) clean
	@rm -f config.mak

config.mak: $(VERSION_FILE) configure
	@$(ECHO) "regenerate $@ ..."
	./configure

.PHONY: clang-format
clang-format:
	clang-format --version
	clang-format -i {src,data}/*.[ch] \
		src/{gtk-im,im-client,modules}/*.[ch] \
		src/qt5-im/*.h \
		src/qt5-im/*.cpp \
		--verbose

=== cmake/external/cld3/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(external_cld3 INTERFACE IMPORTED GLOBAL)
add_library(desktop-app::external_cld3 ALIAS external_cld3)

if (DESKTOP_APP_USE_PACKAGED)
    find_package(protobuf CONFIG)
    find_library(DESKTOP_APP_CLD3_LIBRARIES NAMES cld3)
    find_path(DESKTOP_APP_CLD3_INCLUDE_DIRS NAMES nnet_language_identifier.h PATH_SUFFIXES cld3)
    if (protobuf_FOUND AND DESKTOP_APP_CLD3_LIBRARIES AND DESKTOP_APP_CLD3_INCLUDE_DIRS)
        list(APPEND DESKTOP_APP_CLD3_LIBRARIES protobuf::libprotobuf-lite)
        target_include_directories(external_cld3 SYSTEM INTERFACE ${DESKTOP_APP_CLD3_INCLUDE_DIRS})
        target_link_libraries(external_cld3 INTERFACE ${DESKTOP_APP_CLD3_LIBRARIES})
        return()
    endif()
endif()

add_library(external_cld3_bundled STATIC)
init_target(external_cld3_bundled "(external)")

set(cld3_loc ${third_party_loc}/cld3)
set(cld3_src ${cld3_loc}/src)

set(gen_loc ${CMAKE_CURRENT_BINARY_DIR}/gen)
set(gen_dst ${gen_loc}/cld_3/protos)

if (DESKTOP_APP_USE_PACKAGED OR LINUX)
    find_package(protobuf REQUIRED CONFIG)
    set(protoc_executable protobuf::protoc)
    set(protobuf_lib protobuf::libprotobuf-lite)
elseif (WIN32)
    set(build_loc ${libs_loc}/protobuf/build/$<IF:$<CONFIG:Debug>,Debug,Release>)
    set(protoc_executable ${build_loc}/protoc.exe)
    set(protobuf_lib ${build_loc}/libprotobuf-lite.lib)
else()
    set(protoc_executable ${libs_loc}/protobuf/build/protoc)
    set(protobuf_lib ${libs_loc}/protobuf/build/libprotobuf-lite.a)
endif()
if (PROTOBUF_PROTOC_EXECUTABLE)
    set(protoc_executable ${PROTOBUF_PROTOC_EXECUTABLE})
endif()

include(generate_protobuf.cmake)

function(generate protobuf_name)
    generate_single_protobuf(
        external_cld3_bundled
        ${gen_dst}
        ${protobuf_name}
        ${protoc_executable})
endfunction()

generate(feature_extractor.proto)
generate(sentence.proto)
generate(task_spec.proto)

nice_target_sources(external_cld3_bundled ${cld3_src}
PRIVATE
    feature_extractor.proto
    sentence.proto
    task_spec.proto

    base.cc
    embedding_feature_extractor.cc
    embedding_network.cc
    feature_extractor.cc
    feature_extractor.h
    feature_types.cc
    fml_parser.cc
    language_identifier_features.cc
    lang_id_nn_params.cc
    nnet_language_identifier.cc
    registry.cc
    relevant_script_feature.cc
    sentence_features.cc
    task_context.cc
    task_context_params.cc
    unicodetext.cc
    utils.cc
    workspace.cc

    script_span/generated_entities.cc
    script_span/getonescriptspan.cc
    script_span/getonescriptspan.h
    script_span/utf8statetable.cc
    script_span/offsetmap.cc
    script_span/text_processing.cc
    script_span/text_processing.h
    script_span/fixunicodevalue.cc
)

target_compile_definitions(external_cld3_bundled
PUBLIC
    $<$<NOT:$<CONFIG:Debug>>:NDEBUG>
)

if (NOT MSVC)
    target_compile_options_if_exists(external_cld3_bundled
    PRIVATE
        -Wno-implicit-fallthrough
    )
endif()

target_include_directories(external_cld3_bundled
PUBLIC
    ${cld3_src}
    ${gen_loc}
)

if (NOT DESKTOP_APP_USE_PACKAGED AND NOT LINUX)
    target_include_directories(external_cld3_bundled
    PUBLIC
        ${libs_loc}/protobuf/src
        ${libs_loc}/protobuf/third_party/abseil-cpp
    )
endif()

target_link_libraries(external_cld3_bundled
PUBLIC
    ${protobuf_lib}
)

target_link_libraries(external_cld3
INTERFACE
    external_cld3_bundled
)

=== cmake/external/glib/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(external_glib INTERFACE IMPORTED GLOBAL)
add_library(desktop-app::external_glib ALIAS external_glib)

find_package(PkgConfig REQUIRED)
pkg_check_modules(DESKTOP_APP_GLIB2 REQUIRED IMPORTED_TARGET glib-2.0 gobject-2.0 gio-2.0 gio-unix-2.0)

target_link_libraries(external_glib
INTERFACE
    PkgConfig::DESKTOP_APP_GLIB2
)

target_compile_definitions(external_glib
INTERFACE
    GLIB_VERSION_MIN_REQUIRED=GLIB_VERSION_2_56
    GLIB_VERSION_MAX_ALLOWED=GLIB_VERSION_2_56
)

block()
    set(BUILD_TESTING OFF)
    set(BUILD_DOC OFF)
    set(BUILD_EXAMPLES OFF)
    add_subdirectory(cppgir EXCLUDE_FROM_ALL)
endblock()

include(generate_cppgir.cmake)

if (DESKTOP_APP_GLIB2_gio-unix-2.0_VERSION VERSION_GREATER_EQUAL 2.86)
    generate_cppgir(external_glib GioUnix-2.0)
else()
    generate_cppgir(external_glib Gio-2.0)
endif()

=== cmake/external/glibmm/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(external_glibmm INTERFACE IMPORTED GLOBAL)
add_library(desktop-app::external_glibmm ALIAS external_glibmm)

find_package(PkgConfig REQUIRED)
pkg_check_modules(DESKTOP_APP_GLIBMM REQUIRED IMPORTED_TARGET glibmm-2.68>=2.77 giomm-2.68>=2.77)

target_link_libraries(external_glibmm
INTERFACE
    PkgConfig::DESKTOP_APP_GLIBMM
)

=== cmake/external/gsl/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(external_gsl INTERFACE IMPORTED GLOBAL)
add_library(desktop-app::external_gsl ALIAS external_gsl)

if (DESKTOP_APP_USE_PACKAGED)
    find_package(Microsoft.GSL 4.1.0 QUIET)
    if (Microsoft.GSL_FOUND)
        target_link_libraries(external_gsl INTERFACE Microsoft.GSL::GSL)
        return()
    endif()
endif()

# https://gitlab.kitware.com/cmake/cmake/-/issues/25222
if (NOT EXISTS ${third_party_loc}/GSL/include)
    message(FATAL_ERROR "Guidelines Support Library is not found")
endif()

target_include_directories(external_gsl SYSTEM
INTERFACE
    ${third_party_loc}/GSL/include
)

=== cmake/external/openal/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(external_openal INTERFACE IMPORTED GLOBAL)
add_library(desktop-app::external_openal ALIAS external_openal)

if (DESKTOP_APP_USE_PACKAGED OR LINUX)
    find_package(OpenAL REQUIRED CONFIG)
    target_link_libraries(external_openal INTERFACE OpenAL::OpenAL)
    return()
elseif (WIN32)
    target_include_directories(external_openal SYSTEM
    INTERFACE
        ${libs_loc}/openal-soft/include
        ${libs_loc}/openal-soft/include/AL
    )
    target_link_libraries(external_openal
    INTERFACE
        ${libs_loc}/openal-soft/build/$<IF:$<CONFIG:Debug>,Debug,RelWithDebInfo>/OpenAL32.lib
    )
elseif (APPLE)
    target_include_directories(external_openal SYSTEM
    INTERFACE
        ${libs_loc}/local/include
        ${libs_loc}/local/include/AL
    )
    target_link_libraries(external_openal
    INTERFACE
        ${libs_loc}/local/lib/libopenal.a
    )
endif()

target_compile_definitions(external_openal
INTERFACE
    AL_LIBTYPE_STATIC
)

=== cmake/external/openh264/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

if (DESKTOP_APP_USE_PACKAGED)
    add_library(external_openh264 INTERFACE IMPORTED GLOBAL)
    add_library(desktop-app::external_openh264 ALIAS external_openh264)

    find_package(PkgConfig)
    if (PkgConfig_FOUND)
        pkg_check_modules(DESKTOP_APP_OPENH264 IMPORTED_TARGET openh264)
    endif()

    target_link_libraries(external_openh264 INTERFACE PkgConfig::DESKTOP_APP_OPENH264)
    return()
endif()

add_library(external_openh264 STATIC IMPORTED GLOBAL)
add_library(desktop-app::external_openh264 ALIAS external_openh264)

if (WIN32)
    target_include_directories(external_openh264 SYSTEM
    INTERFACE
        ${libs_loc}/local/include
    )
    set_target_properties(external_openh264 PROPERTIES
        IMPORTED_LOCATION "${libs_loc}/openh264/builddir-release/libopenh264.a"
        IMPORTED_LOCATION_DEBUG "${libs_loc}/openh264/builddir-debug/libopenh264.a"
    )
elseif (APPLE)
    target_include_directories(external_openh264 SYSTEM
    INTERFACE
        ${libs_loc}/local/include
    )
    set_target_properties(external_openh264 PROPERTIES
        IMPORTED_LOCATION ${libs_loc}/local/lib/libopenh264.a
    )
else()
    find_library(DESKTOP_APP_OPENH264_LIBRARIES libopenh264.a REQUIRED)
    set_target_properties(external_openh264 PROPERTIES
        IMPORTED_LOCATION "${DESKTOP_APP_OPENH264_LIBRARIES}"
    )
endif()

=== Telegram/ThirdParty/nimf/debian/changelog ===
nimf (1.3.5) noble; urgency=medium

  * Release for Ubuntu 24.04
  * Support QT6

 -- HamoniKRTeam <pkg@hamonikr.org>  Wed, 12 Jun 2024 10:01:49 +0900

nimf (1.3.4) stable; urgency=medium

  * Release for Ubuntu 24.04
  * Removed gtk 2.0
  * Override test step in rules

 -- HamoniKRTeam <pkg@hamonikr.org>  Sat, 08 Jun 2024 00:18:01 +0900

nimf (1.3.3) stable; urgency=medium

  * Release for arm64
  * Tested on raspberry pi 4, 400
  * Support APT for focal(bullseye) and jammy(bookworm)

 -- HamoniKRTeam <pkg@hamonikr.org>  Mon, 04 Dec 2023 00:36:11 +0900

nimf (1.3.1) stable; urgency=medium

  * Support Arch Linux, Manjaro
  * Replace indicator icons

 -- HamoniKRTeam <pkg@hamonikr.org>  Sat, 03 Dec 2022 16:51:23 +0900

nimf (1.3.0hamonikr40.9) stable; urgency=medium

  * Release for Debian 12 Bookworm

 -- HamoniKRTeam <pkg@hamonikr.org>  Thu, 24 Nov 2022 19:57:21 +0900

nimf (1.3.0hamonikr40.8) stable; urgency=medium

  * Release for Ubuntu 22.04 Jammy

 -- HamoniKRTeam <pkg@hamonikr.org>  Thu, 31 May 2022 14:25:13 +0900

nimf (1.3.0hamonikr40.7) stable; urgency=medium

  * Synchronizing Release Versions

 -- HamoniKRTeam <pkg@hamonikr.org>  Thu, 24 Dec 2021 16:57:08 +0900

nimf (1.3.0hamonikr40.6) stable; urgency=medium

  * Release for Ubuntu 21.10 Impish

 -- HamoniKRTeam <pkg@hamonikr.org>  Thu, 23 Dec 2021 16:57:08 +0900

nimf (1.3.0hamonikr40.5) stable; urgency=medium

  * Release for Ubuntu 21.04 Hirsute

 -- HamoniKRTeam <pkg@hamonikr.org>  Fri, 19 Mar 2021 16:42:20 +0900

nimf (1.3.0hamonikr40.4) stable; urgency=medium

  * Remove doc/nimf-info.png
  * Update README.md 
  * Update nimf/po/ko.po
  * Change distributor name to Hodong Kim
  * Update nimf/modules/services/indicator/nimf-indicator.c
  * Change distributor name to Hodong Kim

 -- HamoniKRTeam <pkg@hamonikr.org>  Tue, 08 Dec 2020 09:49:50 +0900

nimf (1.3.0hamonikr40.3) stable; urgency=medium

  * Update nimf/configure.ac
  * Change version string to 1.3.0
  * Add doc/nimf-info.png and doc/nimf.png
  * Update README.md 
  * Update nimf/po/ko.po
  * Change distributor name as HamoniKR
  * Update nimf/modules/services/indicator/nimf-indicator.c
  * Change distributor name as HamoniKR

 -- HamoniKRTeam <pkg@hamonikr.org>  Tue, 01 Dec 2020 15:23:33 +0900

nimf (1.3.0hamonikr40.2) stable; urgency=medium

  * Rebuild deb package for HamoniKR 4.0
  * Apply new icons for modules
  * Remove modules/engines/nimf-m17n/icons/scalable/nimf-m17n-ui.svg
  * Fix bug for nimf/modules/engines/nimf-m17n/test-nimf-m17n.c 

 -- HamoniKRTeam <pkg@hamonikr.org>  Tue, 01 Dec 2020 15:23:33 +0900

nimf (1.3.0hamonikr40.1) stable; urgency=medium

  * Rebuild deb package for HamoniKR 4.0
  * Build for auto upgrade on HamoniKR 4.0 Jin
 
 -- HamoniKRTeam <pkg@hamonikr.org>  Sun, 29 Nov 2020 18:07:32 +0900

nimf (2020.04.28-1+hamonikr40.2) focal; urgency=low

  * Apply patch for HamoniKR 4.0
  * Update icons on data/icons/scalable folder
  * Apply new icon for HamoniKR 4.0
  * Update AUTHORS, README
  * Changed contact into AUTHORS for fix #23
  * Add BUILD.md and README.md
  * Add build descriptions for HamoniKR 4.0 (Ubuntu 20.04)
  * Update modules/services/indicator/nimf-indicator.c
  * Change display maintainer name  

 -- HamoniKR Team <pkg@hamonikr.org>  Sun, 29 Nov 2020 17:57:07 +0900

nimf (2020.04.28-0~20200428~hamonikr40.1) focal; urgency=low

  * Apply new icons for HamoniKR 4.0

 -- HamoniKR Team <pkg@hamonikr.org>  Tue, 13 Oct 2020 15:32:00 +0900

nimf (2020.04.28) stable; urgency=medium

  * Fixed auto-reordering
  * Fixed errors when typing Hangul with the Dvorak layout.
  * Fixed wrong path. This prevents nimf from running more than once.
    Don't use g_get_user_runtime_dir()
  * Fix an error on compiling im-nimf.c for gtk2

 -- Hodong Kim <nimfsoft@gmail.com>  Tue, 28 Apr 2020 22:14:14 +0900

=== Telegram/ThirdParty/nimf/PKGBUILD ===
# Maintainer: Kevin Kim <root@hamonikr.org>

pkgname=nimf
pkgver=v1.3.5.r8.7e55f06
pkgrel=1
pkgdesc="Nimf is an input method framework."
arch=('any')
url="https://github.com/hamonikr/nimf"
license=('LGPL3')
makedepends=('binutils' 'autoconf' 'automake' 'gcc' 'make' 'glib2' 'intltool'
             'gtk3' 'gtk2' 'qt5-base' 'qt6-base' 'libappindicator-gtk3' 'libayatana-appindicator' 'librsvg'
             'noto-fonts-cjk' 'libhangul-git' 'anthy' 'librime' 'libxkbcommon'
             'wayland' 'wayland-protocols' 'libxklavier' 'm17n-lib' 'm17n-db' 'gtk-doc')
depends=('glib2' 'gtk3' 'gtk2' 'qt5-base' 'qt6-base' 'libappindicator-gtk3' 'libhangul-git'
         'anthy' 'librime' 'libxkbcommon' 'wayland' 'libxklavier' 'm17n-lib'
         'm17n-db')
provides=('nimf-git')
conflicts=('nimf-git')         
optdepends=('brise: Rime schema repository'
            'noto-fonts-cjk: Google Noto CJK fonts')
source=("git+https://github.com/hamonikr/nimf.git")
md5sums=('SKIP')

pkgver() {
	cd nimf
	printf "%s" "$(git describe --long | sed 's/nimf-//' | sed 's/\([^-]*-\)g/r\1/;s/-/./g')"
}

build() {
	cd nimf
	./autogen.sh --prefix=/usr --enable-gtk-doc
	make -j $(nproc)
}

package() {
	cd nimf
	make DESTDIR="${pkgdir}/" install
}

post_install() {
	cat <<EOF
To use Nimf as your input method framework, add the following lines to your ~/.xprofile:

export GTK_IM_MODULE=nimf
export QT4_IM_MODULE="nimf"
export QT_IM_MODULE=nimf
export QT6_IM_MODULE=nimf
export XMODIFIERS="@im=nimf"

EOF
}
